﻿(function()
{
    const TextString = "正在初始化，请稍候";

    var m_ViewDiv;
    var m_BgImage; //image
    var m_Bar;   //image
    var m_BarDi; //image
    var m_Para;  //段落
    var m_Progress = 0.0; //number

    var m_Visible = false;

    var bg_key = IsVertical() ? "preloading_img_bg_ver" : "preloading_img_bg"
    var bar_bg_key = IsVertical() ? "preloading_img_bar_di_ver" : "preloading_img_bar_di"
    var bar_fg_key = IsVertical() ? "preloading_img_bar_fore_ver" : "preloading_img_bar_fore"
    var resconfig = {
        bg: window["sfconfig"][bg_key],
        bardi: window["sfconfig"][bar_bg_key],
        barfore: window["sfconfig"][bar_fg_key],
        cdn: window["sfconfig"]["url_cdn"],
    }

    var m_ResLoadDict = {};
    m_ResLoadDict[resconfig.bardi] = false;
    m_ResLoadDict[resconfig.barfore] = false;

    if(!window.setVirtical){
        window.setVirtical = function(value){
            if(window["SF_Android"]){
                if(value){
                    window["SF_Android"].RotateToPortrait();
                }else{
                    window["SF_Android"].RotateToLandscape();
                }
            }
        }
    }

    function Show()
    {
        m_Visible = true;
        SetAppVertical(IsVertical())
        if(!m_ViewDiv)
        {
            var body = document.getElementsByTagName("body")[0];
            m_ViewDiv = document.createElement("div");
            m_ViewDiv.style.margin = "0";
            m_ViewDiv.style.left = "0px";
            m_ViewDiv.style.top = "0px";
            m_ViewDiv.style.width = "100%";
            m_ViewDiv.style.height = "100%";
            m_ViewDiv.style.position = "absolute";
            m_ViewDiv.style.zIndex = "9900000";
            body.appendChild(m_ViewDiv);

            var bg = new Image();
            bg.style.left = "0px";
            bg.style.top = "0px";
            bg.style.width = "100%";
            bg.style.height = "100%";
            bg.style.position = "absolute";
            bg.src = resconfig.bg;
            bg.onerror = ReloadImage.bind(null, bg, resconfig.cdn)
            m_BgImage = bg;
            m_ViewDiv.appendChild(m_BgImage);

            var leftSpace = GetLeftSpace();
            var bottomSpace = 20;
            var height = IsVertical() ? "1.5%" : "2%";
            var position = "absolute";

            var imageDi = new Image();
            imageDi.style.left = `${leftSpace}%`;
            imageDi.style.width = `${100 - leftSpace * 2}%`;
            imageDi.style.bottom = `${bottomSpace}%`;
            imageDi.style.height = height;
            imageDi.style.position = position;
            imageDi.src = resconfig.bardi;
            imageDi.onload = OnResLoadDone.bind(null, resconfig.bardi);
            imageDi.onerror = ReloadImage.bind(null, imageDi, resconfig.cdn)
            m_BarDi = imageDi;

            var barFore = new Image();
            barFore.style.bottom = `${bottomSpace}%`;
            barFore.style.height = height;
            barFore.style.position = position;
            barFore.style.left = `${leftSpace}%`;
            barFore.src = resconfig.barfore;
            barFore.onload = OnResLoadDone.bind(null, resconfig.barfore);
            barFore.onerror = ReloadImage.bind(null, barFore, resconfig.cdn)
            m_Bar = barFore;

            var para = document.createElement("p");
            var node = document.createTextNode(TextString);
            para.appendChild(node);
            para.style.bottom = `${bottomSpace+1}%`;
            para.style.position = "absolute";
            para.style.color = "#ffedd3";
            para.style.textShadow = "0px 0px #364231";
            var fontSize = IsVertical() ? 0.02 : 0.04
            para.style.fontSize = window.innerHeight * fontSize + "px";
            para.style.textAlign = "center";
            para.style.width = "100%";
            m_Para = para;
            m_ViewDiv.appendChild(para);
        }
    }

    function SetAppVertical(value)
    {
        console.log("SetAppVertical", value)
        if (window["setVirtical"]) {
            // App本身也要适配横竖屏
            window["setVirtical"](value);
            console.log(`window.setVirtical ${value}`);
        }
    }

    function GetLeftSpace()
    {
        return IsVertical() ? 10 : 30
    }

    function IsVertical()
    {
        if(window && window.localStorage)
        {
            var branch = window.localStorage.getItem("branch");
            if (branch) {
                return branch == "Vertical";
            }
        }
        if(window && window["sfconfig"]){
            var vertical =  window["sfconfig"]["vertical"]
            if (vertical == undefined) {
                return true
            }else{
                return vertical ? true : false
            }
        }
        return true;
    }

    // 有时候更新了index页面资源，Native包的也更新为远端资源
    function ReloadImage(img, cdn)
    {
        var url = img.src
        var path = url.split("assets/")[1]
        var newUrl = cdn + "/assets/" + path
        if (newUrl != url){
            img.src = newUrl
            console.log(url)
            console.log("ReloadImage->", newUrl)
        }
        img.onerror = null
    }

    function OnResLoadDone(url)
    {
        if(!m_Visible) return;
        m_ResLoadDict[url] = true;
        CheckResetBar();
    }

    function CheckResetBar()
    {
        if(!m_Visible) return;
        if(m_ResLoadDict[resconfig.bardi] && m_ResLoadDict[resconfig.barfore])
        {
            if(m_ViewDiv)
            {
                m_ViewDiv.appendChild(m_BarDi);
                m_ViewDiv.appendChild(m_Bar);
                SetBarProgress(m_Progress);
            }
        }
    }

    //value范围 0 - 1
    function SetBarProgress(value)
    {
        if(!m_Visible) return;
        m_Progress = value;
        if(m_Bar)
        {
            //删除左右宽度, 剩余的是宽度
            var width = 100 - GetLeftSpace() * 2
            m_Bar.style.width = (m_Progress * width).toString() + "%";
        }
    }

    function Hide()
    {
        m_Visible = false;
        if(m_ViewDiv)
        {
            m_ViewDiv.parentNode.removeChild(m_ViewDiv);
            m_BgImage = null;
            m_Bar = null;
            m_BarDi = null;
            m_ViewDiv = null;
        }
    }

    function GetNatureWidth(img)
    {
        if(img.naturalWidth)
        {
            return img.naturalWidth;
        }
        else
        {
            var temp = new Image();
            temp.src = img.src;
            img.naturalWidth = temp.width;
            delete temp;
            return img.naturalWidth;
        }
    }

    function GetNatureHeight(img)
    {
        if(img.naturalHeight)
        {
            return img.naturalHeight;
        }
        else
        {
            var temp = new Image();
            temp.src = img.src;
            img.naturalHeight = temp.height;
            delete temp;
            return img.naturalHeight;
        }
    }

    window["PreLoading"] = {
        Show: Show,
        Hide: Hide,
        SetBarProgress: SetBarProgress,
    };

    Show();

}());